
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Scanner;
import java.io.PrintWriter;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Thomas
 */
public class SRS_Class {
    
    public static void main(String[] args) throws FileNotFoundException{
        
        String out1;

        double dtmin=1.0e+90;
        double dt;
        double dtmax=-dtmin;

        int MAX=10000000;

        float []ttt =new float[MAX];
        float []aaa =new float[MAX];

//***************************************************************************************

        System.out.println("\n Java_SRS  ver 1.0  June 7, 2010");
        System.out.println(" by Tom Irvine");

        System.out.println("\n This program calculates the SRS of a base input ");
        System.out.println(" acceleration time history. ");

        System.out.println("\n The acceleration file must have two columns:");
        
        System.out.println("   time & acceleration  ");
        System.out.println("\n Enter the acceleration filename:  ");

  
        Scanner myScan;

        myScan = new Scanner(System.in);
        String filename = myScan.nextLine();
        File myFile=new File(filename);

        Scanner scanFile=new Scanner(myFile);

        String test;

        int lineCount = 0;
        int index=-1;
        int iflag=0;
        int jflag=0;
        int header_lines=0;
        int nt=0;

        while(scanFile.hasNextLine()){
            test = scanFile.nextLine();

            iflag=0;

            index = test.indexOf('a');
            if(index>=0)iflag=1;
            index = test.indexOf('b');
            if(index>=0)iflag=1;
            index = test.indexOf('c');
            if(index>=0)iflag=1;
            index = test.indexOf('d');
            if(index>=0)iflag=1;
            index = test.indexOf('f');
            if(index>=0)iflag=1;
            index = test.indexOf('g');
            if(index>=0)iflag=1;
            index = test.indexOf('h');
            if(index>=0)iflag=1;
            index = test.indexOf('i');
            if(index>=0)iflag=1;
            index = test.indexOf('j');
            if(index>=0)iflag=1;
            index = test.indexOf('k');
            if(index>=0)iflag=1;
            index = test.indexOf('l');
            if(index>=0)iflag=1;
            index = test.indexOf('m');
            if(index>=0)iflag=1;
            index = test.indexOf('n');
            if(index>=0)iflag=1;
            index = test.indexOf('o');
            if(index>=0)iflag=1;
            index = test.indexOf('p');
            if(index>=0)iflag=1;
            index = test.indexOf('q');
            if(index>=0)iflag=1;
            index = test.indexOf('r');
            if(index>=0)iflag=1;
            index = test.indexOf('s');
            if(index>=0)iflag=1;
            index = test.indexOf('t');
            if(index>=0)iflag=1;
            index = test.indexOf('u');
            if(index>=0)iflag=1;
            index = test.indexOf('v');
            if(index>=0)iflag=1;
            index = test.indexOf('w');
            if(index>=0)iflag=1;
            index = test.indexOf('x');
            if(index>=0)iflag=1;
            index = test.indexOf('y');
            if(index>=0)iflag=1;
            index = test.indexOf('z');
            if(index>=0)iflag=1;


            index = test.indexOf('A');
            if(index>=0)iflag=1;
            index = test.indexOf('B');
            if(index>=0)iflag=1;
            index = test.indexOf('C');
            if(index>=0)iflag=1;
            index = test.indexOf('D');
            if(index>=0)iflag=1;
            index = test.indexOf('F');
            if(index>=0)iflag=1;
            index = test.indexOf('G');
            if(index>=0)iflag=1;
            index = test.indexOf('H');
            if(index>=0)iflag=1;
            index = test.indexOf('I');
            if(index>=0)iflag=1;
            index = test.indexOf('J');
            if(index>=0)iflag=1;
            index = test.indexOf('K');
            if(index>=0)iflag=1;
            index = test.indexOf('L');
            if(index>=0)iflag=1;
            index = test.indexOf('M');
            if(index>=0)iflag=1;
            index = test.indexOf('N');
            if(index>=0)iflag=1;
            index = test.indexOf('O');
            if(index>=0)iflag=1;
            index = test.indexOf('P');
            if(index>=0)iflag=1;
            index = test.indexOf('Q');
            if(index>=0)iflag=1;
            index = test.indexOf('R');
            if(index>=0)iflag=1;
            index = test.indexOf('S');
            if(index>=0)iflag=1;
            index = test.indexOf('T');
            if(index>=0)iflag=1;
            index = test.indexOf('U');
            if(index>=0)iflag=1;
            index = test.indexOf('V');
            if(index>=0)iflag=1;
            index = test.indexOf('W');
            if(index>=0)iflag=1;
            index = test.indexOf('X');
            if(index>=0)iflag=1;
            index = test.indexOf('Y');
            if(index>=0)iflag=1;
            index = test.indexOf('Z');
            if(index>=0)iflag=1;
            index = test.indexOf('!');
            if(index>=0)iflag=1;
            index = test.indexOf('@');
            if(index>=0)iflag=1;
            index = test.indexOf('#');
            if(index>=0)iflag=1;
            index = test.indexOf('$');
            if(index>=0)iflag=1;
            index = test.indexOf('!');
            if(index>=0)iflag=1;
            index = test.indexOf('%');
            if(index>=0)iflag=1;
            index = test.indexOf('^');
            if(index>=0)iflag=1;
            index = test.indexOf('&');
            if(index>=0)iflag=1;
            index = test.indexOf('*');
            if(index>=0)iflag=1;
            index = test.indexOf('=');
            if(index>=0)iflag=1;
            index = test.indexOf(';');
            if(index>=0)iflag=1;
            index = test.indexOf('/');
            if(index>=0)iflag=1;
            index = test.indexOf('_');
            if(index>=0)iflag=1;

            if(iflag==1)header_lines++;

            lineCount++;
          }
          scanFile.close();

       try {

            Scanner fin = new Scanner(new FileReader(myFile));

            if(header_lines>0)
            {
               for(int i=0;i<header_lines;i++)
               {
                   test = fin.nextLine();
               }
            }

            int i=1;

            String s;

            System.out.println(" Select input time unit:");
            System.out.println("  1=sec  2=msec");

            Scanner scan = new Scanner(System.in);
            String timeUnit = scan.nextLine();

            int tu= Integer.parseInt(timeUnit.trim());


            while (fin.hasNext() && nt<MAX)
            {
               s = fin.next();


//               System.out.println(s);
               try {

                   if(i==1)
                   {
                       ttt[nt] = Float.valueOf(s.trim()).floatValue();

                       if(tu==2)
                       {
                          ttt[nt]/=1000.;
                       }

                       if(nt>=1)
                       {
                         dt=(ttt[nt]-ttt[nt-1]);
                         if( dt<dtmin){dtmin=dt;}  
                         if( dt>dtmax){dtmax=dt;}                             
                       }    
             
                       i=2;
                   }
                   else
                   {
                       aaa[nt] = Float.valueOf(s.trim()).floatValue();
                                      
                       nt++;
                       i=1;
                   }

                }
                catch (NumberFormatException nfe)
                {
                      System.out.println("NumberFormatException: " + nfe.getMessage());
                }

       } // end while loop
       fin.close();

    }
    catch (NumberFormatException nfe)
    {
            System.out.println("NumberFormatException: " + nfe.getMessage());
    }

    String out2;

    dt=(ttt[nt-1]-ttt[0])/(nt-1);

    System.out.println(String.format("dtmin= %9.5g",dtmin));
    System.out.println(String.format("   dt= %9.5g",dt));
    System.out.println(String.format("dtmax= %9.5g \n",dtmax));

    double srmin = 1/dtmax;
    double sr = 1/dt;
    double srmax = 1/dtmin;

    System.out.println(String.format("srmin= %9.5g",srmin));
    System.out.println(String.format("   sr= %9.5g",sr));
    System.out.println(String.format("srmax= %9.5g",srmax));


    if(dtmin<=0 || ((dtmax-dtmin)/dtmax)>0.02);
    {
       System.out.println("\n Enter new sample rate");

       Scanner scan = new Scanner(System.in);
       String newSR = scan.nextLine();

       float nsf=Float.parseFloat(newSR.trim());

       dt=1/nsf;
    }
          
   SRS_Engine(ttt,aaa,dt,sr,nt);

  }

  public static void SRS_Engine(float []ttt,float []aaa,double dt,double sr,int nt) throws FileNotFoundException{

    Scanner scan = new Scanner(System.in);
    String out2;

    System.out.println("Enter the damping format:  1=damping ratio   2=Q ");
    String dampingFormat = scan.nextLine();

    int i = Integer.parseInt(dampingFormat.trim());

    double damp;

    if(i==1)
    {
        out2 = "Enter damping ratio ";
        System.out.println(out2);
        String dampingValue = scan.nextLine();

        damp=Double.parseDouble(dampingFormat.trim());
    }
    else
    {
        out2 = "Enter the Q value ";
        System.out.println(out2);
        String dampingValue = scan.nextLine();

        damp=Double.parseDouble(dampingValue.trim());

        damp=1./(2.*damp);
    }

    System.out.println(String.format("\n damping ratio= %9.5g       ",damp));
    System.out.println(String.format("\n            dt= %9.5g sec \n",dt));


    System.out.println("Enter starting frequency (Hz)");
    String f1_s = scan.nextLine();
    Float f1=Float.parseFloat(f1_s.trim());


    System.out.println("Select alogrithm: ");
    System.out.println("1=Kelly-Richman  2=Smallwood ");
    String algorithm_s = scan.nextLine();
    
    int algorithm = Integer.parseInt(algorithm_s.trim());


    System.out.println("Include residual? ");
    System.out.println("1=yes  2=no ");
    String residual_s = scan.nextLine();

    int residual = Integer.parseInt(residual_s.trim());


    double []fn =new double[200];

    fn[0]=f1;

    int jnum=0;

    int j;

    for(j=1; j< 200; j++)
    {
        fn[j]=fn[0]*Math.pow(2.,j*(1./12.));
        
        if( fn[j] > sr/8.){break;}
    }
    jnum=j;


    double omega;
    double omegad;

    double []a1=new double[jnum];
    double []a2=new double[jnum];
    double []b1=new double[jnum];
    double []b2=new double[jnum];
    double []b3=new double[jnum];

     if(algorithm==1)
     {
        double cosd;
        double sind;
        double domegadt;

	for(j=0;j<jnum;++j)
	{

			omega=2.*Math.PI*fn[j];

			omegad=omega*Math.sqrt(1.-Math.pow(damp,2));

			cosd=Math.cos(omegad*dt);

			sind=Math.sin(omegad*dt);

			domegadt=damp*omega*dt;

			a1[j]=2.*Math.exp(-domegadt)*cosd;
			a2[j]=-Math.exp(-2.*domegadt);

			b1[j]=2.*domegadt;
			b2[j]=omega*dt*Math.exp(-domegadt);
			b2[j]*=( (omega/omegad)*(1.-2.*Math.pow(damp,2))*sind -2.*damp*cosd );

			b3[j]=0.;
		}
	}
	else
	{

            double C,E,K,S,Sp;

		for(j=0;j<jnum;++j)
		{

			omega=2.*Math.PI*fn[j];

			omegad=omega*Math.sqrt(1.-Math.pow(damp,2));

			E=Math.exp(-damp*omega*dt);
			K=omegad*dt;
			C=E*Math.cos(K);
			S=E*Math.sin(K);

			Sp=S/K;

			a1[j]=2*C;
			a2[j]=-Math.pow(E,2);

			b1[j]=1.-Sp;
			b2[j]=2.*(Sp-C);
			b3[j]=Math.pow(E,2)-Sp;

	       }
    }

    double []x=new double[jnum];
    double []xb=new double[jnum];
    double []xbb=new double[jnum];

    double []xmin=new double[jnum];
    double []xmax=new double[jnum];

    double []tmin=new double[jnum];
    double []tmax=new double[jnum];

    double y;
    double []yb=new double[jnum];
    double []ybb=new double[jnum];

    for(j=0;j<jnum;j++)
    {
         xb[j]=0.;
        xbb[j]=0.;
         yb[j]=0.;
        ybb[j]=0.;

        tmin[j]=0.;
        tmax[j]=0.;

        xmin[j]=1.0e+90;
        xmax[j]=-xmin[j];
    }

    int nt1=nt;


    for(j=0;j<jnum;j++)
    {

        if(residual==1)
        {
           nt=nt1 + (int)(1./fn[j]);
        }

        for(i=0;i<nt;i++)
        {
           y=0.;

           if(i<nt1)
           {
              y=aaa[i];
           }

           x[j]=  a1[j]*xb[j] +a2[j]*xbb[j] +b1[j]*y +b2[j]*yb[j] +b3[j]*ybb[j];

	   if(x[j] > xmax[j])
	   {
		xmax[j]=x[j];
//		tmax[j]=ttt[i];
	   }
	   if(x[j] < xmin[j])
	   {
		xmin[j]=x[j];
//		tmin[j]=ttt[i];
	   }

	   xbb[j]=xb[j];
	    xb[j]= x[j];
	   ybb[j]=yb[j];
	    yb[j]= y;

        } // end nt

     }// end j fn

     Scanner myScan;

     System.out.println("\n Enter the postive & negative SRS output filename:  ");
     myScan = new Scanner(System.in);
     String filename1 = myScan.nextLine();
     File myFile1=new File(filename1);
     PrintWriter pwOutput1 = new PrintWriter(myFile1);

     for(j=0;j<jnum;j++)
     {
        pwOutput1.println(String.format("%12.7e \t %12.7e \t %12.7e ",fn[j],Math.abs(xmax[j]),Math.abs(xmin[j])));
     }
     pwOutput1.close();


     System.out.println("\n Enter the absolute SRS output filename:   ");
     myScan = new Scanner(System.in);
     String filename2 = myScan.nextLine();
     File myFile2=new File(filename2);
     PrintWriter pwOutput2 = new PrintWriter(myFile2);

     double xmaxa=0.;
     double fna=0.;

     for(j=0;j<jnum;j++)
     {
        if(Math.abs(xmax[j])<Math.abs(xmin[j]))
        {
            xmax[j]=xmin[j];
        }
        xmax[j]=Math.abs(xmax[j]);

        pwOutput2.println(String.format("%12.7e \t %12.7e ",fn[j],xmax[j]));

        if(xmax[j]>xmaxa)
        {
            xmaxa=xmax[j];
            fna=fn[j];
        }
     }
     pwOutput2.close();

      System.out.println("\n SRS Output Formats: \n");
      System.out.println(String.format("%s fn(Hz)  max(G)  min(G)   ",filename1));
      System.out.println(String.format("%s fn(Hz)  abs max(G)    ",filename2));

      System.out.println(String.format("\n Peak Response =  %8.4g G  at  %8.4g  Hz",xmaxa,fna));

    }// end SRS_engine
 }